#!/bin/bash

shopt -s extglob

prime=$1

if [[ -z $prime ]]
then
    echo "usage: instantiate.bash <prime>"
    exit 1
fi

if [[ $prime != @(17|31|47|79|97|113) ]]
then
    echo "error: prime must be one of: 17 31 47 79 97 113"
    exit 1
fi

f=inv-check.$prime.out

inv-check.bash $prime > $f

awk '

BEGIN { line_num = -1; }

/Symmetric polynomial/ {
    sym_poly = $3;
    gsub(/\^/,"\\^", sym_poly);
    gsub(/\*/,"\\*", sym_poly);
    line_num = NR;
}

NR == line_num + 1 {
    sub(/.*,/, "");
    value = $0;
    printf("s/%s/%s/g\n", sym_poly, value);
}

' < $f > test.sed

sed -f test.sed < poly-template.bc > poly.$prime.bc


